# include/xapian/unicode.h File Reference

Unicode and UTF-8 related classes and functions. More...

`#include <xapian/visibility.h>`
`#include <string>`

Include dependency graph for unicode.h:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Namespaces

namespace | Xapian
namespace | Xapian::Unicode
namespace | Xapian::Unicode::Internal

## Classes

class | Xapian::Utf8Iterator
| An iterator which returns unicode character values from a UTF-8 encoded string. More...

## Enumerations

enum

category {
UNASSIGNED, UPPERCASE_LETTER, LOWERCASE_LETTER, TITLECASE_LETTER,
MODIFIER_LETTER, OTHER_LETTER, NON_SPACING_MARK, ENCLOSING_MARK,
COMBINING_SPACING_MARK, DECIMAL_DIGIT_NUMBER, LETTER_NUMBER, OTHER_NUMBER,
SPACE_SEPARATOR, LINE_SEPARATOR, PARAGRAPH_SEPARATOR, CONTROL,
FORMAT, PRIVATE_USE, SURROGATE, CONNECTOR_PUNCTUATION,
DASH_PUNCTUATION, OPEN_PUNCTUATION, CLOSE_PUNCTUATION, INITIAL_QUOTE_PUNCTUATION,
FINAL_QUOTE_PUNCTUATION, OTHER_PUNCTUATION, MATH_SYMBOL, CURRENCY_SYMBOL,
MODIFIER_SYMBOL, OTHER_SYMBOL
}

| Each unicode character is in one of these categories. More...

## Functions

XAPIAN_VISIBILITY_DEFAULT int | Xapian::Unicode::Internal::get_character_info (unsigned ch)
int | Xapian::Unicode::Internal::get_case_type (int info)
| Extract how to convert the case of a unicode character from its info.
category | Xapian::Unicode::Internal::get_category (int info)
| Extract the category of a unicode character from its info.
int | Xapian::Unicode::Internal::get_delta (int info)
| Extract the delta to use for case conversion of a character from its info.
XAPIAN_VISIBILITY_DEFAULT unsigned | Xapian::Unicode::nonascii_to_utf8 (unsigned ch, char *buf)
| Convert a single non-ASCII unicode character to UTF-8.
unsigned | Xapian::Unicode::to_utf8 (unsigned ch, char *buf)
| Convert a single unicode character to UTF-8.
void | Xapian::Unicode::append_utf8 (std::string &s, unsigned ch)
| Append the UTF-8 representation of a single unicode character to a std::string.
category | Xapian::Unicode::get_category (unsigned ch)
| Return the category which a given unicode character falls into.
bool | Xapian::Unicode::is_wordchar (unsigned ch)
| Test is a given unicode character is a letter or number.
bool | Xapian::Unicode::is_whitespace (unsigned ch)
| Test is a given unicode character is a whitespace character.
bool | Xapian::Unicode::is_currency (unsigned ch)
| Test is a given unicode character is a currency symbol.
unsigned | Xapian::Unicode::tolower (unsigned ch)
| Convert a unicode character to lowercase.
std::string | Xapian::Unicode::tolower (const std::string &term)
| Convert a UTF-8 std::string to lowercase.

## Detailed Description

Unicode and UTF-8 related classes and functions.